package {{ package }};

import zeus.util.mysql.mapper.Extractor;
import zeus.util.mysql.mapper.ValuesMap;
import zeus.util.mysql.mapper.types.Converters;
import com.mysql.cj.xdevapi.Row;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import {{ clazz }};

public class {{ extractorClassName }} implements Extractor {

    @Override
    public Object rowToObject(Row row) {
        {%- if entityCreatorArgs -%}
            return new {{ className }}(
            {%- for arg in entityCreatorArgs -%}
                {%- if (loop.first) -%}
                {%- else -%}
                    ,
                {%- endif -%}

                {% if (arg.converterMethodName) %}
                    Converters.{{ arg.converterMethodName }}(
                        row.{{ arg.columnValueGetter }}("{{ arg.columnName }}")
                    )
                {% else %}
                    row.{{ arg.columnValueGetter }}("{{ arg.columnName }}")
                {%- endif -%}
            {%- endfor -%}
            );

        {%- else -%}
            throw new IllegalArgumentException("Can't find @EntityCreator annotated constructor");
        {%- endif -%}
    }

    @Override
    public ValuesMap objectToMap(Object obj, String prefix) {
        {{ className }} casted = ({{ className }}) obj;
        ValuesMap map = new ValuesMap();
        {% for getter in columnValueGetters %}
        map.put(
            prefix + "{{ getter.columnName }}",
            {%- if (getter.converterMethodName) -%}
                Converters.{{ getter.converterMethodName }}(
                    casted.{{ getter.methodName }}()
                )
            {%- else -%}{##}
                casted.{{ getter.methodName }}()
            {%- endif -%}{##}
        );
        {%- endfor -%}{##}

        return map;
    }

}